#pragma config(Sensor, S1,     pravo,          sensorEV3_Ultrasonic)
#pragma config(Sensor, S2,     Gyro,           sensorEV3_Gyro)
#pragma config(Sensor, S3,     ,               sensorEV3_Color, modeEV3Color_Color)
#pragma config(Sensor, S4,     pryamo,         sensorEV3_Ultrasonic)
/*sdelano na inversii motorov
b=levyi
c=pravyu
*/
int masL[1000];
int len=0;
int angle=0,e,u,k=1,eG,v=40,a=370;
int flag=1;
float i=0;
float kG=0.2076645,ki=0.011589;
float kGL=0.2078645,kiL=0.011499;
void forward()
{
	wait1Msec(100);
	nMotorEncoder[motorB]=0;
	nMotorEncoder[motorC]=0;
	wait1Msec(200);
	while(nMotorEncoder[motorB]>-a)
	{
		e = angle - getGyroDegrees(Gyro);
		u=e*k;
		motor[motorB]=-(v+u);
		motor[motorC]=-(v-u);
	}
	nMotorEncoder[motorB]=0;
	nMotorEncoder[motorC]=0;
	playSound(soundBlip);
	wait1Msec(200);
}
void vira()
{
	motor[motorB]=motor[motorC]=-15;
	wait1Msec(2000);
	motor[motorB]=motor[motorC]=10;
	wait1Msec(300);
	nMotorEncoder[motorB]=0;
	nMotorEncoder[motorC]=0;
}
void abc()
{
	playSound(soundBeepBeep);
	if(flag!=1)
	{
		if(SensorValue[S4]<15)
		{
			vira();
		}
	}
}
void right_gyro()
{
	i=0;
	wait1Msec(200);
	angle=angle+88;
	while(getGyroDegrees(S2)<angle)
	{
		eG=angle-getGyroDegrees(S2);
		i=i+ki*eG;
		if(abs(i)>20)
		{
			i=sgn(i)*20;
		}
		u=eG*kG+i;
		motor[motorB]=-u;
		motor[motorC]=u;
		wait1Msec(10);
	}
	i=0;
	angle=angle+2;
	motor[motorB]=0;
	motor[motorC]=0;
	nMotorEncoder[motorB]=0;
	nMotorEncoder[motorC]=0;
	abc();
}
void left_gyro()
{
	i=0;
	wait1Msec(200);
	angle=angle-89;
	while(getGyroDegrees(S2)>angle)
	{
		eG=angle-getGyroDegrees(S2);
		i=i+kiL*eG;
		if(abs(i)>20)
		{
			i=sgn(i)*20;
		}
		u=eG*kGL+i;
		motor[motorB]=-u;
		motor[motorC]=u;
		wait1Msec(10);
	}
	angle=angle-1;
	i=0;
	motor[motorB]=0;
	motor[motorC]=0;
	nMotorEncoder[motorB]=0;
	nMotorEncoder[motorC]=0;
}
void byPath()
{
	for(int i=0; i<len; i++)
	{
		switch(masL[i])
		{
		case 1: right_gyro(); break;
		case 2: left_gyro(); abc(); break;
		case 3: forward();
		}
	}
}
void byPath_invers()
{
	for(int i=len; i>=0; i--)
	{
		switch(masL[i])
		{
		case 1: left_gyro(); abc(); break;
		case 2: right_gyro(); break;
		case 3: forward();
		}
	}
}
void cut_element(int j)
{
	for(int k=j;k<len-1;k++)
	{
		masL[k]=masL[k+1];
	}
	len--;
	masL[len]=0;
}
void cut()
{
	i=0;
	while(i++<len)
	{
		if(masL[i]==2 && masL[i-1]==2)
		{
			cut_element(i-1);
			cut_element(i-1); i--;
			while((masL[i]+ masL[i-1])%3==0)
			{
				cut_element(i-1);
				cut_element(i-1); i--;
			}
			if(masL[i] == masL[i-1])
			{
				cut_element(i-1);
				cut_element(i-1);i--;
			}
			else
			{
				if(masL[i] < masL[i-1])
				{
					masL[i]=3-masL[i];
				}
				else
				{
					masL[i-1]=3-masL[i-1];
				}
			}
		}
	}
	i=0;
}
task main()
{
	resetGyro(S2);
	sleep(200);
	angle=getGyroDegrees(S2);
	while(flag==1)
	{
		if(SensorValue[S3]!=1)//csvet ne raven black "niggers"
		{
			if (SensorValue[S1]>25)
			{
				playSound(soundBeepBeep);
				right_gyro();
				if(flag==1) masL[len++]=1;
				forward();
				if(flag==1) masL[len++]=3;
				sleep(200);
			}
			else
			{
				if(SensorValue[S4]>25)
				{
					forward();
					if(flag==1) masL[len++]=3;
					sleep(200);
				}
				else
				{
					vira();
					left_gyro();
					if(flag==1) masL[len++]=2;
					sleep(1);
				}
			}
		}
		else
		{
			flag=0;
		}
	}
	motor[motorB]=0;
	motor[motorC]=0;
	cut();
	a=470;
	while(!getButtonPress(buttonEnter)==1) sleep(1);
	resetGyro(Gyro);
	angle=0;
	byPath();
	left_gyro();
	left_gyro();
	byPath_invers();
}
